<?php
/* Skript pro výpis adresáře, vytváření a mazání podadresářů, ukládání a mazání
 * souborů. Tento soubor je psán v UTF-8, proto k jeho editaci není možno použít
 * např. Notepad (Poznámkový blok), ale např. PSPad.
 *
 * Verze 2.5, únor 2011
 *
 * Copyright © Petr Červinka 2008—2011 <petr@programator.unas.cz>
 */

/* =============================== Nastavení: =============================== */


$vytvareni_adresaru = true;   //Možnost vytváření nových adresářů.
$mazani_adresaru    = true;   //Možnost mazání prázdných adresářů.
$cist_podadresare   = true;   //Čtení podadresářů (při vypnutí jen odkazy).
$skryt_odkaz_nahoru = false;  //Skryje odkaz o úroveň výš v nejvyšší úrovni.

$ukladani_souboru   = true;   //Možnost ukládat nové soubory.
$prepis_souboru     = false;  //Možnost přepisovat soubory novými.
$mazani_souboru     = true;   //Možnost mazání souborů.
$cist_soubory       = false;  //Čtení souborů skriptem (při vypnutí jen odkazy).
$skryt_konf_soubory = true;   //Nezobrazí soubory jako .htaccess nebo .htpasswd.
$povolit_zakazane   = false;  //Povolí ukládání zakázaných typů souborů (viz níže).

/* Seznam typů souborů, které nebude možno uložit z formuláře (lze doplnit nebo
 * ubrat podle potřeby):
 */

$zakazane_typy = "php, php3, php4, phtml, asp, aspx, cgi, pl, py, sh, htaccess, htpasswd";

/* Znaková sada filesystému serveru:
 * Pokud bude tento skript používán na serveru, který běží na Linuxu, je třeba
 * v českém prostředí nastavit znakovou sadu např. "iso-8859-2", v případě
 * Windows např. "windows-1250".
 */

$znakova_sada_fs = "iso-8859-2";


/* ========================================================================== */


/* Vypnutí chybových hlášení: */

error_reporting(0);

/* Generování ikon: */

if (isset($_GET["ikona"])){
   $data = array (
"pdf" =>
"R0lGODlhEAAQAMQdAOCPj+BAQOCvr+CwsOBPT9/Pz9/Q0OCfn+Bvb9/g4OBfX+9fX+CAgOAwMO9Q
UOBQX+C/v+B/f+BwcOAvL+8/P+BgYO9AT+Cwv+A/QBAQEP8AAAAAAN/f3////wAAAAAAACH5BAEA
AB0ALAAAAAAQABAAAAVjYCduZFlmmahuXOu2mZaaNMnF8qbtPM+eul6P5crUaK/U6EUQvG6rF+bw
VHaIrYnElYAuW4cCAJGMcgwLwaBBCTwuViIjAIgMBICKJc5RBJ5nEHEIBAWAHAlxDodFKiiPkJAh
ADs=",

"rtf" =>
"R0lGODlhEAAQAKIGAMDAwICAgP8AAAAA/wAAAP///////wAAACH5BAEAAAYALAAAAAAQABAAAANL
aBrcrtCEQisFIcrSLODRNHAWYRKQSA7sCKBLIQiTVbxpcRatC282z0/UGwluw6DsiIv1ZNAmsDKb
IXMsKIWZVF6GgLB4LD2Zz4QEADs=",

"html" =>
"R0lGODlhEAAQANUyAMDAwF12m3iVhE+R11WoapTNjLnOw1V5fImgvp/OokBmm4DTYWiQ7+nw0ZW2
maO/pE1ymzeKb4ij19bk1GisZkBclUeKm3CRx+rr3m6XgVGRm3Ckw2Ssj7fEzlqD1s7SszJqSZ+/
nau8u5jVmcLrz5OzqTagYU5nhiaaOOLs3jqBSrzEsEOhhWmarfPXboCAgAAAAP//0P///wAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAADIALAAAAAAQABAAAAZxQJnw
RSwahUjZK8ZsMgGvpNLpBMSiyCWVCevCslun6ztspgyhB4Y5BscmCdJI02rE2uVYaVHYDEwOd2RT
MQgUHAwWKBmCbhIXBCwQIAKNeR0eESoKFR+WhDEiBycBK2yDWmGfqWF4Si6wsbKuXrW2MEEAOw==",

"txt" =>
"R0lGODlhEAAQAKIEAMDAwICAgAAAAP///////wAAAAAAAAAAACH5BAEAAAQALAAAAAAQABAAAAM7
SBrcrpCEQSsFIUprwcjQxFFCKYRjdy6kqaLptW6D6Q7ALMY5bJcyGE/XsgVZMRwx2VsAntBok/Cr
lhIAOw==",

"script" =>
"R0lGODlhEAAQAMQdAHNzc5qamoKCgmdnZ2RkZFtbW8LCwnZ2dj8/P46OjqSkpENDQwwMDCcnJ7a2
tkBAQKqqqnBwcBsbG2pqalhYWM7OzvLy8ubm5r+/v9ra2jMzMwAAAP///////wAAAAAAACH5BAEA
AB0ALAAAAAAQABAAAAV3YCeOHbKRqLhtCIedqYplCebC6IZZlWDfuV3lQOAYgTKeYAIZHJGMQkAQ
MVwqxeOrUzAAAI7LhefUrjCXjNjCySyeGU1Ht+akH8f4SMdOCwJGeiQNaBkHARltciQSCgMZAIiK
KRQVAAKPkykbABoriIsxJBuhJCEAOw==",

"jpg" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBP///wAAAICAAP///yH5BAEAAAcALAAAAAAQABAAAANE
eHrT/msNQSsdIDJBuhdONHnfVZxoqp5G674v6xmdWxss3RI67+a+G88H3NmMsuDrloM5casoSsQh
fQZUixYreXgHgQQAOw==",

"gif" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///wCAAP///yH5BAEAAAcALAAAAAAQABAAAANF
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674va3StN3tsAeuzm/e1Gu0H5PEMMtpNd5TBnsiVFCXi
kD6DqmWblTy+g0ACADs=",

"png" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///4AAAP///yH5BAEAAAcALAAAAAAQABAAAANF
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674v27UFTdeyUc+7K9c6XQ9HCNqCwELumCTCnr6VFCXi
kD6DqmWblTy+g0ACADs=",

"tif" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///wAAmf///yH5BAEAAAcALAAAAAAQABAAAANG
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674v6xkzabC0W7S7i/c5Wqf10/FihKNwB7wlYVDiaooS
cUifgdXC1Uoe4EEgAQA7",

"bmp" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///wAA/////yH5BAEAAAcALAAAAAAQABAAAANF
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674v27UFbcyGfN/eXsu1nS+oqwWNLqDNlyTAns2V9CTi
kD6DqmWblTy+g0ACADs=",

"psd" =>
"R0lGODlhEAAQALMIAICAAPv7+4aGhsDAwAQEBP//////AAAAAP///wAAAAAAAAAAAAAAAAAAAAAA
AAAAACH5BAEAAAgALAAAAAAQABAAAARHEElEqr1zksE7J0FGDUVpDla2med3vHAsv0Zt3zf9AgZA
Gz8dcDg8FI27WvBIJCKZRlsyGMVZgbMsTEVinQhcjxisuZgJgggAOw==",

"tga" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///wCAgP///yH5BAEAAAcALAAAAAAQABAAAANE
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674v67WdW7Sscevvfec7H40HHPJmRVqQSIA5XatoSsQh
fQZUixYreXgHgQQAOw==",

"pcx" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBP///wAAAICAgP///yH5BAEAAAcALAAAAAAQABAAAANF
eHrT/msNQSsdIDJBuhdONHnfVZxoqp5G674v27kz0dqyYds0L/O8m6+go71mhlyvWGTBnq2VNCXi
kD6DqmWblTy+g0ACADs=",

"pict" =>
"R0lGODlhEAAQAKIHAPv7+4aGhsDAwAQEBAAAAP///wAAgP///yH5BAEAAAcALAAAAAAQABAAAANF
eHrT/msNQSsdIDJRuhdONHnfRZxoqp5G674v27UFXXuycetvLdc8IM2QGwp5RZ4O6CPAnq6VNCXi
kD6DqmWblTy+g0ACADs=",

"wmf" =>
"R0lGODlhEAAQAKIGAPv7+4aGhsDAwAQEBP///wAAAP///wAAACH5BAEAAAYALAAAAAAQABAAAAM9
aGrT/msNQSsdIDJBuhdONHnfVZxoqq6sSqDvW8TdKc+zh8O8TPu4mG3XGwZbyGRLxCF9BkyLFCp5
WAeBBAA7",

"image" =>
"R0lGODlhEAAQAOZIAMvj/vP5/pim03WEt+fGJojI+7LY/bLV+rvL86jK9dPp/oKg08Lh/pOaxCNv
1czV/+Px/tTJ1qO85sLb/9Pd5/Pz80Om97PK8drk6ZzG9Yiq3A6n4uPs9jxsvZOWwUKW5UZGrJOa
zIWKtGr6Me7XY/DMKZnL/K2w/MZ6ev3MAN3jxmx0pYmRuVfwT6PR/u80DpShyubo6OXUCNzJIwiU
8ur0/VlDl+7w8VKr9oKczHi38rHF8b/DgXmNwHuUxwuL8arU/rrb/tvt/v4zAACZ/oep3P39/mZm
Zv///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5
BAEAAEgALAAAAAAQABAAAAewgEiCRYSFGgtFA4KLSEVGj5ABRTpHjI2QjwEBFhYflYuOkQE1Dw8n
A5+XQ6soDEIQQgoIqUUVq0MdREQFCgCzoLZDNg66REG+tDdDLyDEugUTF6kLHBERPzQbuibRqTkx
sAUtI0Q4BkE7qT4YQkIkKTIzGUEHCak97ColBPw8QPWpBlDoFcTAASAIgUgISAEAAAZBCgJxkWDh
ohUCMgqAEaJBAw8sRKRCcqSkyZMlAwEAOw==",

"generic" =>
"R0lGODlhEAAQAKIEAMDAwICAgAAAAP///////wAAAAAAAAAAACH5BAEAAAQALAAAAAAQABAAAAM1
SBrcrpCEQSsFIUprwcjQxFFCKYRjdy5pBaxbO7yoTLM2LLZ3zOuyGTBX+4UAyKSyZ2o6BQkAOw==",

"dir" =>
"R0lGODlhEAAQAKIGAPHx8f/5yKGRZM++jwAAAPPisf///wAAACH5BAEAAAYALAAAAAAQABAAAAM6
aLrc/k5ISaARIIRSRI1DKA5TeWloihYDIWxcLHPtO9+sC+NxvfM5G5CmGxKFw9pouawQntCo1PJI
AAA7",

"back" =>
"R0lGODlhEAAQALMJAPHx8cvLy5aWlv/5yP+CgqGRZM++jwAAAPPisf///wAAAAAAAAAAAAAAAAAA
AAAAACH5BAEAAAkALAAAAAAQABAAAARMMMlJq722aH1wKsAwIEjRZUaqGlv7iSIBz4hxFCNC7GRP
2jjdjuer3XICgiBQNAZJw2EPmBNGBb+jT8DtZp9NH3BFJncO6LR67blEAAA7",

"doc" =>
"R0lGODlhEAAQAKIFAICAgMDAwAAA/wAAAP///////wAAAAAAACH5BAEAAAUALAAAAAAQABAAAANR
WArcrrAAQisFQ4mxOx8XkYFWJVBD+nle4BJBuolnRwUwR9TgEOPAFG21A+Z4MQHO94r1eJRTJVmq
MIOrrPSWWZRcza6kaolBAOB0WoxRud0JADs=",

"xls" =>
"R0lGODlhEAAQAKIFAACAAMDAwAAAAICAgP///////wAAAAAAACH5BAEAAAUALAAAAAAQABAAAANP
WDrcrrAMQisdQoGxK5/ElH0dSQmoABBb+wUwEWSruwUUPmvsC8e7Vk8ok6lMrp+RxBlaZramUJdZ
VFzFnfWnA1YllrARMuCaYV9Mar1OAAA7",

"pps" =>
"R0lGODlhEAAQAKIHAICAgAAAgMDAwP8A/wAA/wAAAP///////yH5BAEAAAcALAAAAAAQABAAAANQ
eHrQ7qvIOY1t8YFirwEKRxiCwHXUURDDAJhdZ6oGaxVlThYqJcWWWSaYE+wyBQAwyFsEZMWjIkBd
MqfUatE4y3qXwkN2W2yKqT6fk7poLxIAOw==",

"ppt" =>
"R0lGODlhEAAQAKIGAICAgICAAMDAwAAAAP8AAP///////wAAACH5BAEAAAYALAAAAAAQABAAAANQ
aArcrtCAQitligTNd7gFYHxWRVBDOpydVgRCXAjDtxUsbtH568Iyms3So/BwpF9MMKv5PMXmqUQB
MoUt6G4Amcxmyyt3Qd12w+jYWKJquxMAOw==",

"css" =>
"R0lGODlhEAAQAKIEAMDAwICAgAAAAP///////wAAAAAAAAAAACH5BAEAAAQALAAAAAAQABAAAAM+
SBrcrpCEQSsFIUprwcjQxFFCKYRjdy7kJ17rlsLoILgMzc4DEIs3h04289WCjeErZdwVf4CodNok
mK5YQQIAOw==",

"zip" =>
"R0lGODlhEAAQAOZRAGdofrCTOrO00o2OssupQ9S1VHZ3lZaXsNm8ZsOsY414LJmDNoJqIfnpvMGq
Y/fqw9OwRqWUXs6rRNG7fI2OqNu8YMSrZraWOMWtY7GSNoeHmMKrY52dsaSFLr+dPKOGL+/htN7L
k8u0cvjqwtW/g9i6YMauZtO3YayMMtC1YYuMpn5/l31+lfPov8auYq2qtKGDLM2yYvTmvcCePbqa
Ovbqwvfou9vJj/DhttKvRsivYsWiQLybO9LT5Pnqv8OhP+raqt29YPjpvMimQvjqwNGuRaqMM+PT
n7WUOMajQOTTnurbq/nqwdOvRqGDK6KMPvjwv////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5
BAEAAFEALAAAAAAQABAAAAeggFGCg4SCEQUIDIWLAgADBoNNkhBFBDseNBcZRh8BUU0NDT5MIzUt
OEtHNxMmTp9PsEEVJScpMToYCQ6uTU9QULDBT07ETp5Rvr/KwCoAGiyDycvAjT0HgwvTvwuNL9eC
CtpQChQAHCuCveLDxZ69wsIuCRu7nzZCRA8PMiBASiEkRFiAIQhCkxwSCAxJ8mMGDyQoOhxbJOgR
xUWHEg0KBAA7",

"rar" =>
"R0lGODlhEAAQAOZKABE2AAAyUODg8JicqP//saGmsYSHl/D4//L5/+/2/ZOXpPX6/77H0zIyMtTc
5ICAAFBQAABQhQBYp8XFHgBWnwBUlm8aIEit/wBWnACKWjJQAP+H117puo0CU+hatSzipRVDAGO5
//++8Fu1/7m5AADckjmm/wBUlAA4bv990kLlrozvzf9syvRjwACHV/+j5SWd/7Dk/xbfm40GUbv1
4XLrwgGDU5vS/wA4Xv+V3v950IXI/1nouHPA/3NzAABXogCIWJICWtDY4IYCU1AAAFgdABlOAAA8
Z////wAAAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5
BAEAAEoALAAAAAAQABAAAAebgEWCg4SFSgUDCgYWPkOOj49EDEJCAjMEIi85Gyk6LC0eREIHSEgW
E0GpqqkdRAsICQ4ND0S1trdJubq7vIeJBjgRR8PExAGTlREEMTc7PSEjFyYwAaOlKBMSEj8UFBgV
FScBr7GzxecBvOq7voogEEbx8vIAyAIQBDQrNRw8Kh8ySgCwhkQDiQxAEip0YQMAOVkP5kkEsK6i
kkAAOw==",

"mid" =>
"R0lGODlhEAAQAKIFAMDAwICAgIAAgAAAAP///////wAAAAAAACH5BAEAAAUALAAAAAAQABAAAANF
WBrcrrAEQisFIUprAcnQRAlCNZxDWJFkBaTLSrQXvI14realHs+9HuGlYuWGtgmNhtyNmMTfs5Pk
cKISgHbLxaK+4EECADs=",

"sound" =>
"R0lGODlhEAAQAKIEAMDAwICAgAAAAP///////wAAAAAAAAAAACH5BAEAAAQALAAAAAAQABAAAAND
SBrcrpCEQSsFIUprwcjQRAlCRZKheVaAkI4DybqLCV/0dpf4K8ez1ArYq/1+g9ZrhFTWVJ2ciBNc
AK7YrJNw6noFCQA7",

"video" =>
"R0lGODlhEAAQAKIEAMDAwAAA/////wAAAP///wAAAAAAAAAAACH5BAEAAAQALAAAAAAQABAAAAM9
SDrcPio2QesA8Gnxgv/fIGANaIoYpz1jIzFVRUILF1MpTUz3/Io9Vw0Yy/1uLcYxqBwijQsGYEr1
RVeOBAA7",

"exe" =>
"R0lGODlhEAAQAOZhADly4pOit/7+//b4/fL1/J6uw+Tq+e/z/Ovw+/j6/mWV8/H1/aOyyO/z+9bh
9snX8/X3/fb5/aLC//39/vn7/vv8/uft+WKO5vr7/j524/z9/vj6/YSl6dDc9Ozw+ujt+pq9/fP2
/Xqf6dni9pqpvkp945a5/Hab6Pf5/Z/A/tzl9/3+/s7b9N/m+GyU51aG5U6B5FiH5c3a9Nzm9+Ho
+O7y/Pf6/Zalunei9n2n+G6X54am6kB248bV8vz8/kZ75OHp+Nvk98PS8v7//+Dn+Pn6/tTf9f7+
/svY9PP2/ISr+Yuw+vv7/uTr+S9iyOju+ezw+8HR8dLd9fv9/mqZ9TFlzf3+/9/n+JC1+/v8/8XT
8vj5/X+h6XGd9Yuq6jVJY////////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5
BAEAAGEALAAAAAAQABAAAAesgGGCg4SFYV6IiDtcJy4XMTA/GRkAXhISKSAmWEtKOThdVAoKVYle
HCI6Fy8lPACvAE4MYLS1tgIaFChfBba+R1MUEQa8vrUrPkUDSVdfs8YCWRsRIQdBxb4CFQkDBAce
Dl8kvlZM3N5QT1JfN7fb3TUIH00yXwG1Exg2EAsNCBYGaDywB2ZIvi38/AEkMkOLPQ1AWqgY4cBI
BxZIHvQQEsXel48gQ4o0RHJQIAA7");

   header("Content-type: image/gif");
   echo base64_decode($data[$_GET["ikona"]]);
   exit;
}

/* Čtení souborů: */

if ($cist_soubory && isset($_GET["file"])){
   if (ereg("^\.*[/\\]|[/\\]\.*[/\\]|[/\\]\.*$", $_GET["file"])) exit;
   if (!file_exists($_GET["file"])) exit;
   $mime_typy = array (
   "pdf"  => "application/pdf",
   "rtf"  => "application/rtf",
   "txt"  => "text/plain",
   "log"  => "text/plain",
   "nfo"  => "text/plain",
   "diz"  => "text/plain",
   "m3u"  => "audio/x-mpegurl",
   "php"  => "text/plain",
   "php3" => "text/plain",
   "php4" => "text/plain",
   "phtml"=> "text/plain",
   "asp"  => "text/asp",
   "aspx" => "text/asp",
   "js"   => "application/x-javascript",
   "vbs"  => "text/plain",
   "cgi"  => "text/plain",
   "pl"   => "text/plain",
   "py"   => "text/x-script.phyton",
   "sh"   => "application/x-sh",
   "ps"   => "application/postscript",
   "eps"  => "application/postscript",
   "html" => "text/html",
   "shtml"=> "text/html",
   "htm"  => "text/html",
   "css"  => "text/css",
   "doc"  => "application/msword",
   "xls"  => "application/excel",
   "xla"  => "application/excel",
   "xlb"  => "application/excel",
   "xlc"  => "application/excel",
   "xld"  => "application/excel",
   "ppt"  => "application/mspowerpoint",
   "pps"  => "application/mspowerpoint",
   "jpg"  => "image/jpeg",
   "jpe"  => "image/jpeg",
   "jpeg" => "image/jpeg",
   "jif"  => "image/jpeg",
   "jfif" => "image/jpeg",
   "gif"  => "image/gif",
   "png"  => "image/png",
   "tif"  => "image/tiff",
   "tiff" => "image/tiff",
   "xif"  => "image/vnd.xiff",
   "bmp"  => "image/bmp",
   "dib"  => "image/bmp",
   "rle"  => "image/rle",
   "pict" => "image/pict",
   "pct"  => "image/pict",
   "pcx"  => "image/pcx",
   "dcx"  => "image/pcx",
   "tga"  => "image/targa",
   "wmf"  => "image/wmf",
   "mid"  => "audio/mid",
   "midi" => "audio/mid",
   "rmi"  => "audio/mid",
   "mp1"  => "audio/mpeg",
   "mp2"  => "audio/mpeg",
   "mp3"  => "audio/mpeg",
   "mp4"  => "audio/mpeg",
   "mpa"  => "audio/mpeg",
   "ogg"  => "audio/x-ogg",
   "wav"  => "audio/wav",
   "wma"  => "audio/x-ms-wma",
   "aiff" => "audio/aiff",
   "aif"  => "audio/aiff",
   "aifc" => "audio/aiff",
   "au"   => "audio/au",
   "snd"  => "audio/snd",
   "avi"  => "video/avi",
   "m1v"  => "video/mpeg",
   "m2v"  => "video/mpeg",
   "mpeg" => "video/mpeg",
   "mpg"  => "video/mpeg",
   "mpe"  => "video/mpeg",
   "vob"  => "video/mpeg",
   "wmv"  => "video/x-ms-wmv",
   "wm"   => "video/x-ms-wm",
   "ra"   => "audio/x-realaudio",
   "rm"   => "audio/x-realaudio",
   "ram"  => "audio/x-realaudio",
   "asf"  => "video/x-ms-asf",
   "asx"  => "video/x-ms-asf",
   "ivf"  => "video/x-ivf",
   "mov"  => "video/quicktime",
   "qt"   => "video/quicktime",
   "flv"  => "video/x-flv",
   "swf"  => "application/x-shockwave-flash",
   "zip"  => "application/x-compressed",
   "z"    => "application/x-compressed",
   "gz"   => "application/x-compressed",
   "tgz"  => "application/x-compressed",
   "tar"  => "application/x-compressed",
   "bz"   => "application/x-bzip",
   "bz2"  => "application/x-bzip2");
   $f = pathinfo($_GET["file"]);
   $p = strtolower($f["extension"]);
   $mime = array_key_exists($p, $mime_typy) ? $mime_typy[$p] :
           "application/octet-stream";
   $fp = fopen($_GET["file"], "r");
   header("Content-Disposition: inline; filename=\"".$f["basename"]."\"");
   header("Content-Type: ".$mime);
   while(!feof($fp)){ 
      echo fread($fp, 8192);
   }
   fclose($fp);
   exit;
}

/* Funkce pro zjištění velikosti souboru: */

function zjisti_velikost($f){
   $s = filesize($f);
   if ($s < 1000){
      return str_replace(".", ",", round($s, 2))." B";
   }
   $s = $s / 1024;
   if ($s < 1000){
      return str_replace(".", ",", round($s, 2))." kB";
   }
   $s = $s / 1024;
   if ($s < 1000){
      return str_replace(".", ",", round($s, 2))." MB";
   }
   return str_replace(".", ",", round($s, 2))." GB";
}

/* Funkce pro zkrácení jména souboru: */

function zkrat_jmeno_souboru($jmeno, $delka){
   $d = strlen($jmeno);
   if ($d > $delka){
      return substr($jmeno, 0, $delka-3)."&#8230;";
   }else{
      return $jmeno;
   }
}

/* Funkce pro úpravu jména souboru na bezpečný tvar: */

function uprav_jmeno_souboru($jmeno){
   $j = iconv("UTF-8", "ISO-8859-2//IGNORE", $jmeno);
   $d = iconv("UTF-8", "ISO-8859-2", "ÁáÄäČčĎďÉéĚěËëÍíĹĺĽľŇňÓóÔôÖöŘřŔŕŠšŤťÚúŮůÜüÝýŽž");
   $j = strtr($j, $d, "AaAaCcDdEeEeEeIiLlLlNnOoOoOoRrRrSsTtUuUuUuYyZz");
   $p = pathinfo($j, PATHINFO_EXTENSION);
   $l = ereg_replace("^(.*)\..*$", "\\1", $j);
   $l = ereg_replace("[^[:alnum:]-]", "_", $l);
   return substr($l, 0, 46).".".$p;
}

/* Funkce pro úpravu jména adresáře na bezpečný tvar: */

function uprav_jmeno_adresare($jmeno){
   $j = iconv("UTF-8", "ISO-8859-2//IGNORE", $jmeno);
   $d = iconv("UTF-8", "ISO-8859-2", "ÁáÄäČčĎďÉéĚěËëÍíĹĺĽľŇňÓóÔôÖöŘřŔŕŠšŤťÚúŮůÜüÝýŽž");
   $j = strtr($j, $d, "AaAaCcDdEeEeEeIiLlLlNnOoOoOoRrRrSsTtUuUuUuYyZz");
   $j = ereg_replace("[^[:alnum:]-]", "_", $j);
   return substr($j, 0, 50);
}

/* Funkce k zjištění, je-li zadaný adresář prázdný: */

function prazdny_adresar($dir){
   $dp = opendir ($dir);
   while ($di = readdir($dp)){
      if ($di=="." || $di=="..") continue;
      return false;
   }
   return true;
}

/* Funkce pro přiřazení ikony: */

function ikona($soubor){
   $ikona =  array (  "pdf"  => "pdf",   "rtf"  => "rtf",   "txt"  => "txt",
   "log"  => "txt",   "nfo"  => "txt",   "diz"  => "txt",   "m3u"  => "sound",
   "pls"  => "txt",   "php"  => "script","php3" => "script","php4" => "script",
   "phtml"=> "script","asp"  => "script","aspx" => "script","js"   => "script",
   "vbs"  => "script","cgi"  => "script","pl"   => "script","py"   => "script",
   "sh"   => "script","html" => "html",  "shtml"=> "html",  "htm"  => "html",
   "css"  => "css",   "doc"  => "doc",   "xls"  => "xls",   "xla"  => "xls",
   "xlb"  => "xls",   "xlc"  => "xls",   "xld"  => "xls",   "ppt"  => "ppt",
   "pps"  => "pps",   "jpg"  => "jpg",   "jpe"  => "jpg",   "jpeg" => "jpg",
   "jif"  => "jpg",   "jfif" => "jpg",   "gif"  => "gif",   "png"  => "png",
   "tif"  => "tif",   "tiff" => "tif",   "xif"  => "tif",   "tga"  => "tga",
   "bmp"  => "bmp",   "dib"  => "bmp",   "rle"  => "bmp",   "psd"  => "psd",
   "emf"  => "image", "fpx"  => "image", "ico"  => "image", "cur"  => "image",
   "ani"  => "image", "iff"  => "image", "lbm"  => "image", "ilbm" => "image",
   "pbm"  => "image", "pcd"  => "image", "pcx"  => "pcx",   "dcx"  => "pcx",
   "pgm"  => "image", "pic"  => "image", "pict" => "pict",  "pct"  => "pict",
   "pix"  => "image", "ppm"  => "image", "wmf"  => "wmf",   "xbm"  => "image",
   "xpm"  => "image", "exe"  => "exe",   "com"  => "exe",   "scr"  => "exe",
   "rar"  => "rar",   "zip"  => "zip",   "z"    => "zip",   "gz"   => "zip",
   "tgz"  => "zip",   "tar"  => "zip",   "cab"  => "zip",   "bz"   => "zip",
   "bz2"  => "zip",   "mid"  => "mid",   "midi" => "mid",   "rmi"  => "mid",
   "mp1"  => "sound", "mp2"  => "sound", "mp3"  => "sound", "mp4"  => "sound",
   "mpa"  => "sound", "ogg"  => "sound", "wav"  => "sound", "wma"  => "sound",
   "aiff" => "sound", "aif"  => "sound", "aifc" => "sound", "au"   => "sound",
   "snd"  => "sound", "avi"  => "video", "divx" => "video", "m1v"  => "video",
   "m2v"  => "video", "mpeg" => "video", "mpg"  => "video", "mpe"  => "video",
   "ogm"  => "video", "vob"  => "video", "wmv"  => "video", "wm"   => "video",
   "ra"   => "video", "rm"   => "video", "ram"  => "video", "sf"   => "video",
   "asf"  => "video", "asx"  => "video", "ivf"  => "video", "mov"  => "video",
   "qt"   => "video", "mkv"  => "video", "flv"  => "video");
   $alt   =  array (  "log"  => "TXT",   "nfo"  => "TXT",   "diz"  => "TXT",
   "php3" => "PHP",   "php4" => "PHP",   "phtml"=> "PHP",   "shtml"=> "HTML",
   "htm"  => "HTML",  "jpe"  => "JPEG",   "jpg" => "JPEG",  "jif"  => "JPEG",
   "jfif" => "JPEG",  "tiff" => "TIFF",  "xif"  => "TIFF",  "dib"  => "BMP",
   "rle"  => "BMP",   "emf"  => "IMG",   "fpx"  => "IMG",   "ico"  => "IMG",
   "cur"  => "IMG",   "ani"  => "IMG",   "iff"  => "IMG",   "lbm"  => "IMG",
   "ilbm" => "IMG",   "pbm"  => "IMG",   "pcd"  => "IMG",   "dcx"  => "PCX",
   "pic"  => "IMG",   "pct"  => "PICT",  "midi" => "MID",   "rmi"  => "MID");
   if (ereg("\.\.$", $soubor) && is_dir($soubor)){
      $i = "back";
      $a = "DIR";
   }elseif (is_dir($soubor)){
      $i = "dir";
      $a = "DIR";
   }else{
      $p = strtolower(pathinfo($soubor, PATHINFO_EXTENSION));
      $i = array_key_exists($p, $ikona) ? $ikona[$p] : "generic";
      $a = array_key_exists($p, $alt) ? $alt[$p] : strtoupper($p);
   }
   return "<img src=\"".$_SERVER["PHP_SELF"]."?ikona=".$i.
          "\" width=\"16\" height=\"16\" align=\"top\" alt=\"[".$a."]\">";
}

/* Funkce pro zformátování data: */

function datum($d){
   return date("d.m.Y, H:i:s", filemtime($d));
}

/* Zpracování: */

$prac = str_replace("\\", "/", dirname($_SERVER["PHP_SELF"]));
if (!$cist_podadresare ||
    ereg("^\.*([/\\]|\.$)|[/\\]\.*[/\\]|[/\\]\.*$", $_GET["dir"])){
   $dir = "";
}else{
   $dir = $_GET["dir"];
}
if ($dir!="" && is_dir($dir)){
   $prep = $dir."/";
   $prad = $prac=="/" ? $prac.$dir : $prac."/".$dir;
}else{
   $dir = $prep = "";
   $prad = $prac;
}
if (isset($_GET["d"])){
   if (is_dir($prep.$_GET["d"]) && $mazani_adresaru){
      @rmdir($prep.$_GET["d"]);
   }elseif (is_file($prep.$_GET["d"]) && $mazani_souboru){
      @unlink($prep.$_GET["d"]);
   }
}elseif ($_FILES && $ukladani_souboru){
   if ($_FILES["soubor"]["error"] == UPLOAD_ERR_INI_SIZE){
      $chyba = "Soubor je příliš velký, maximální velikost je ".
               ini_get("upload_max_filesize").".";
   }elseif ($_FILES["soubor"]["error"] == UPLOAD_ERR_NO_FILE){
      $chyba = "Nejprve je třeba vybrat soubor, který má být uložen.";
   }elseif ($_FILES["soubor"]["error"]){
      $chyba = "Soubor se nepodařilo uložit.";
   }else{
      $f = uprav_jmeno_souboru($_FILES["soubor"]["name"]);
      $prip = strtolower(pathinfo($f, PATHINFO_EXTENSION));
      $zakp = split(",[[:space:]]*", $zakazane_typy);
      if ($dir=="" && $f==basename($_SERVER["PHP_SELF"])){
         $chyba = "Indexový soubor nelze přepsat.";
      }elseif (!$povolit_zakazane && in_array($prip, $zakp)){
         $chyba = "Tento soubor nelze z bezpečnostních důvodů uložit.";
      }elseif (!$prepis_souboru && file_exists("./".$dir."/".$f)){
         $chyba = "Soubor s názvem <b>\"".htmlspecialchars($f).
                  "\"</b> už existuje.";
      }else{
         move_uploaded_file($_FILES["soubor"]["tmp_name"], "./".$dir."/".$f);
      }
   }
}elseif (isset($_POST["adresar"]) && $vytvareni_adresaru){
   if (!$n = $_POST["adresar"]==""){
      $a = uprav_jmeno_adresare($_POST["adresar"]);
      if (!$e = file_exists("./".$dir."/".$a)){
         @mkdir("./".$dir."/".$a);
      }
   }
}

$pradc = iconv($znakova_sada_fs, "utf-8//IGNORE", $prad);

$titul = $del=="" ? "Obsah adresáře ".$pradc : "Potvrzení";

$date = gmdate("D, d M Y H:i:s", time());
header("Cache-Control: no-cache, must-revalidate");
header("Expires: ".$date." GMT");
header("Content-Type: text/html; charset=utf-8");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
 "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<title><?php echo $titul; ?></title>
<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
<meta http-equiv="Expires" content="<?php echo $date; ?> GMT">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Content-Language" content="cs">
<style type="text/css">
body {
   background-color: #FFF;
   color: #000;
   font-family: Verdana, Arial, sans-serif;
   font-size: small;
}
h1 {
   color: #B29100;
   font-size: large;
}
hr {
   height: 1px;
   background-color: #8AC;
   color: #87AACC;
   border: 0;
}
img {
   border: 0;
}
strong {
   color: #B29100;
}
th {
   border-top: 1px solid #8AC;
   border-bottom: 1px dashed #9BD;
}
a:link, a:visited {
   text-decoration: none;
}
a:hover, a:active {
   text-decoration: underline;
}
.p {
   border-top: 1px dashed #9BD;
   border-bottom: 1px solid #8AC;
}
.a {
   background-color: #FBFDFF;
}
.b {
   background-color: #F4F9FF;
}
input {
   font-family: Verdana, Arial, sans-serif;
}
.s {
   width: 200px;
}
.t {
   font-weight: bold;
   width: 90px;
}
.v {
   color: #F00;
}
</style>
</head>

<body>
<?php
if ($del!=""){
   $co = "souboru";
   if (is_dir($prep.$del)){
      if ($cist_podadresare){
         $odkaz = $_SERVER["PHP_SELF"]."?dir=".urlencode($prep.$del);
      }else{
         $odkaz = iconv($znakova_sada_fs, "utf-8//IGNORE", $prep.$del);
      }
      $co = "adresáře";
   }elseif (is_file($prep.$del) && $cist_soubory){
      $odkaz = $_SERVER["PHP_SELF"]."?file=".urlencode($prep.$del);
   }else{
      $odkaz = iconv($znakova_sada_fs, "utf-8//IGNORE", $prep.$del);
   }
?>
<h1>Potvrzení smazání <?php echo $co; ?></h1>

<table cellpadding="2" cellspacing="0">
<tr>
<th width="420">Název</th>
<th width="100">Velikost</th>
<th>Změněno</th>
</tr>
<?php
   echo "<tr class=\"a\"><td width=\"420\"><a href=\"".$odkaz."\">".
        ikona($prep.$del)." ".zkrat_jmeno_souboru(iconv($znakova_sada_fs,
        "utf-8//IGNORE", $del), 45)."</a></td><td width=\"100\">".
        zjisti_velikost($prep.$del)."</td><td>".datum($prep.$del).
        "</td></tr>\n<tr><td colspan=\"3\">&nbsp;</td></tr>\n</table>\n";
?>
<table>
<tr>
<td>
<form action="<?php
echo $_SERVER["PHP_SELF"]."?dir=".urlencode($dir)."&amp;d=".urlencode($del);
?>" method="post">
<input type="submit" value="Ano" class="t">
</form>
</td>
<td>
<form action="<?php
echo $_SERVER["PHP_SELF"]."?dir=".urlencode($dir);
?>" method="post">
<input type="submit" value="Ne" class="t">
</form>
</td>
</tr>
</table>

<?php }else{ ?>

<h1>Obsah adresáře <?php echo htmlspecialchars($pradc); ?></h1>

<table cellpadding="2" cellspacing="0">
<tr>
<th width="420">Název</th>
<th width="100">Velikost</th>
<th>Změněno</th>
<th width="70">&nbsp;</th>
</tr>
<?php

/* Přečtení adresáře: */

if ($dp = @opendir("./".$dir)){
   for ($i = 0; $sb = readdir($dp);){
      if ($sb!="." && ($dir!="" || $sb!=basename($_SERVER["PHP_SELF"])) &&
         ($dir!="" || $sb!=".." || $prac!="/" && !$skryt_odkaz_nahoru) &&
         (!ereg("^\.ht", $sb) || !$skryt_konf_soubory)){
         $m = strtolower($sb);
         $pm[$i] = $m;
         $ab[$m] = $sb;
         $i++;
      }
   }
   closedir($dp);
   if ($i > 0){
      sort ($pm);
   }
}

for ($j = 0; $j < $i; $j++){
   $fn = $ab[$pm[$j]];
   $v = is_file($prep.$fn) ? zjisti_velikost($prep.$fn) : "&ndash;";
   $trida = $j%2 ? "a" : "b";
   if ($fn==".."){
      $odkaz = $_SERVER["PHP_SELF"]."?dir=".
               urlencode(ereg_replace("^\.$", "", dirname($dir)));
   }elseif (is_dir($prep.$fn)){
      if ($cist_podadresare){
         $odkaz = $_SERVER["PHP_SELF"]."?dir=".urlencode($prep.$fn);
      }else{
         $odkaz = iconv($znakova_sada_fs, "utf-8//IGNORE", $prep.$fn);
      }
      $emdir = prazdny_adresar($prep.$fn);
   }elseif (is_file($prep.$fn) && $cist_soubory){
      $odkaz = $_SERVER["PHP_SELF"]."?file=".urlencode($prep.$fn);
   }else{
      $odkaz = iconv($znakova_sada_fs, "utf-8//IGNORE", $prep.$fn);
   }
   if ($fn==".." && $dir==""){
      $odkaz="..";
   }
   echo "<tr class=\"".$trida."\"><td width=\"420\"><a href=\"".$odkaz."\">".
        ikona($prep.$fn)." ".zkrat_jmeno_souboru(iconv($znakova_sada_fs,
        "utf-8//IGNORE", $fn), 45)."</a></td><td width=\"100\">".$v."</td><td>".
        datum($prep.$fn)."</td><td width=\"70\" align=\"center\">";
   if (is_file($prep.$fn) && $mazani_souboru || $emdir && $mazani_adresaru){
      echo "<a href=\"".$_SERVER["PHP_SELF"]."?dir=".urlencode($dir).
           "&amp;del=".urlencode($fn)."\">Smazat</a>";
   }else{
      echo "&nbsp;";
   }
   echo "</td></tr>\n";
}

if ($dir!="" || $prac!="/" && !$skryt_odkaz_nahoru){
   $i--;
}

echo "<tr><td colspan=\"4\" class=\"p\"><i>";

if ($i>0){
   echo "Celkem ".$i;
   if ($i==1){
      echo " položka.";
   }elseif ($i>4){
      echo " položek.";
   }else{
      echo " položky.";
   }
}else{
   echo "Adresář je prázdný.";
}

echo "</i></td></tr>\n</table>\n";

if (isset($chyba)){
   echo "<span class=\"v\"><b>Chyba:</b> ".$chyba."</span><br>\n";
}elseif ($n){
   echo "<span class=\"v\"><b>Chyba:</b> Je třeba zadat název nového adresáře.</span><br>\n";
}elseif ($e){
   echo "<span class=\"v\"><b>Chyba:</b> Adresář s názvem <b>\"".
        htmlspecialchars($a)."\"</b> už existuje.</span><br>\n";
}

if ($ukladani_souboru || $vytvareni_adresaru){

   echo "<table cellpadding=\"2\" cellspacing=\"0\"><tr>\n";

   if ($ukladani_souboru){
      echo "<td width=\"400\">";
      if ($prepis_souboru){
         echo "<strong>Uložit nebo přepsat soubor:</strong><br>\n";
      }else{
         echo "<strong>Uložit nový soubor:<br></strong>\n";
      }
?>
<form action="<?php
echo $_SERVER["PHP_SELF"]."?dir=".urlencode($dir);
?>" method="post" enctype="multipart/form-data">
<p><input type="file" name="soubor" accept="*/*"></p>
<p><input type="submit" value="Uložit" class="t"></p>
</form>
</td>
<?php
   }
   if ($vytvareni_adresaru){
?>
<td><strong>Vytvořit nový adresář:</strong><br>
<form action="<?php
echo $_SERVER["PHP_SELF"]."?dir=".urlencode($dir);
?>" method="post">
<p><input type="text" name="adresar" class="s" value="<?php
if ($ne){
   echo htmlspecialchars($a);
}
?>"></p>
<p><input type="submit" value="Vytvořit" class="t"></p>
</form>
</td>
<?php
   }
   echo "</tr></table>\n";
}}
?>
</body>
</html>
